;---------------------------------------------------------------------
;-----------(C)2008 Luis Antunes Pena---------------------
;-----http://icem.folkwang-hochschule.de/~pena----
;-------Licensed under Creative Commons-------------
;--http://creativecommons.org/licenses/by-sa/3.0/----
;--------------------------------------------------------------------



<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments> ;++++++++++++++++++++++++++++++++++++++++

; Initialize the global variables.
sr = 44100
ksmps = 2205
nchnls = 1


            ; analysis / audio
            strset    10, "$SADIR$PVOCNAME"
            strset    20, "$SSDIR$AUDIONAME"

;initialize global variables
gilen init 0
gifilcod init 10
gitxt init 0


;+++++++++++++++++++++++++++++++++++++++
; values to edit _______________________
gibinmin init 1			;bin min
gibinmax init 256		;bin max

giampmin init $MINAMP	;500		;min amp
giampmax init 0dbfs		;max amp

gifreqmin init 20		;min freq
gifreqmax init $MAXFREQ	;10000	;max freq
; _______________________ values to edit 
;+++++++++++++++++++++++++++++++++++++++


instr 1 ; file info ################
	ifilcod   =  10
	ilen      filelen   ifilcod+10
	gilen      =  ilen
	gifilcod = ifilcod
	turnoff
endin ;#############################


; write pvoc info into file +++++++++++++++++++++++++++++++++++++++++++
instr 5 ;**************************************************************

iampmin = p5
iampmax = p6
ifreqmin = p7
ifreqmax = p8

gkcount init 0

	ibin = p4

    ;read pvoc info 
	ktimpnta  phasor    1/gilen
	ktimpnt   =  ktimpnta * gilen
	kfreq, kamp	pvread	ktimpnt, gifilcod, ibin

 if ((kamp < iampmin) || (kamp > iampmax) || (kfreq < ifreqmin) || (kfreq > ifreqmax)) goto dontwrite

fprintks "$SADIRr_$TXTNAME", "time: %.2f%tfreq: %.4f%tamp: %d%n", ktimpnt, kfreq, kamp
fprintks "$SADIR$TXTNAME", "%.2f%t%.4f%t%d%%n", ktimpnt, kfreq, kamp;, ibin, gkcount, ktime
  
/* to simulate the sound with sinewaves  
  gir ftgen 0, 0, 8193, 10, 1
  asin oscili kamp * 5, kfreq, gir
  out asin  
*/

gkcount = gkcount +1

dontwrite:

endin ;***************************************************************
; +++++++++++++++++++++++++++++++++++++++++++ write pvoc info into file


; control instrument---------------------------------------------------
instr 10 ;-------------------------------------------------------------

ibinmin = gibinmin
ibinmax = gibinmax
iampmin = giampmin
iampmax = giampmax
ifreqmin = gifreqmin
ifreqmax = gifreqmax

ktime timeinsts
ibin = ibinmin

;write header to file
fprints "$SADIR$TXTNAME", "%!analyse file made with csound using pvanal%n%!2008 Luis Antunes Pena%n%n(setf command '("

test:
	if (ibin <= ibinmax) then

			iinstr = 5
			idelay = 0
			idur = gilen
			ip4 = ibin
			ip5 = iampmin
			ip6 = iampmax
			ip7 = ifreqmin
			ip8 = ifreqmax

		event_i "i", iinstr, idelay, idur, ip4, ip5, ip6, ip7, ip8 ;writes binmin until binmax for each time (kr)
				ibin = ibin + 1

		goto test
		
	endif

	if ((ip4 == ibinmax) && (ktime >= gilen)) then
	fprintks "$SADIR$TXTNAME", "))";, ktimpnt, kfreq, kamp	
	turnoff
	endif

endin ;-------------------------------------------------------------
;--------------------------------------------------- control instrument



; print some info ++++++++++++++++++
instr 11
icount = i(gkcount)
prints "%n------ Analysis data ------%n%n file: $SADIR$TXTNAME%n file duration: %.2f [s]%n bins: %d to %d%n amplitude filter: %d to %d [csnd-amp]%n frequency filter: %d to %d [Hz]%n number of values written to file: %d [%d]%n frequency range: %.2f Hz - %.3f kHz%n assuming N = 1024 (pvanal):%n  frequency resolution: %.2f Hz%n  time resolution: %d ms%n%n", gilen, gibinmin, gibinmax, giampmin, giampmax, gifreqmin, gifreqmax, icount-1, gilen*gibinmax/(ksmps/sr), sr/1024, gibinmax*sr/1024/1000, sr/1024, 1000*1024/sr
endin
; ++++++++++++++++++ print some info

</CsInstruments> ;++++++++++++++++++++++++++++++++++++++++



<CsScore> ;-----------------------------------------------
i1	0	.1
i10	0	100
i11	100	.001
e
</CsScore> ;-----------------------------------------------
</CsoundSynthesizer>

<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>72</x>
 <y>179</y>
 <width>400</width>
 <height>200</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>255</r>
  <g>255</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBVSlider">
  <objectName>slider1</objectName>
  <x>5</x>
  <y>5</y>
  <width>20</width>
  <height>100</height>
  <uuid>{a353d9f9-2508-4cd2-9d00-662df57c0d8c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.00000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBVSlider">
  <objectName>slider2</objectName>
  <x>45</x>
  <y>5</y>
  <width>20</width>
  <height>100</height>
  <uuid>{b9949347-9086-40b2-8c65-3ad11d391e0c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.00000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBVSlider">
  <objectName>slider3</objectName>
  <x>85</x>
  <y>5</y>
  <width>20</width>
  <height>100</height>
  <uuid>{9a317ab4-1b11-45c3-b341-e3ba29ad2973}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.00000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBVSlider">
  <objectName>slider4</objectName>
  <x>125</x>
  <y>5</y>
  <width>20</width>
  <height>100</height>
  <uuid>{87342f9a-5e8e-4f19-9609-263393514bb4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.00000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBVSlider">
  <objectName>slider5</objectName>
  <x>165</x>
  <y>5</y>
  <width>20</width>
  <height>100</height>
  <uuid>{511998b4-217c-487e-90dd-faaf7e489886}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.00000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options: -b128 -A -s -m167 -R
</MacOptions>
<MacGUI>
ioView nobackground {65535, 65535, 65535}
ioSlider {5, 5} {20, 100} 0.000000 1.000000 0.000000 slider1
ioSlider {45, 5} {20, 100} 0.000000 1.000000 0.000000 slider2
ioSlider {85, 5} {20, 100} 0.000000 1.000000 0.000000 slider3
ioSlider {125, 5} {20, 100} 0.000000 1.000000 0.000000 slider4
ioSlider {165, 5} {20, 100} 0.000000 1.000000 0.000000 slider5
</MacGUI>
<EventPanel name="" tempo="60.00000000" loop="8.00000000" x="360" y="248" width="596" height="322" visible="true" loopStart="0" loopEnd="0">    </EventPanel>
