#!/bin/csh
clear
echo "#################################################" 
echo ""
echo "                   samp2fft"
echo ""
echo "                 beta version"
echo ""
echo "         (C)2008 Luis Antunes Pena"
echo "       Licensed under Creative Commons"
echo "  http://creativecommons.org/licenses/by-sa/3.0/"
echo ""
echo "  this utility will analyse one audio file"
echo "  and write a text file with the FFT info"
echo ""
echo "#################################################"
echo ""
echo ""
printf "press enter to continue. to abort press command + ."
set foo = "$<"
echo ""
echo "enter SADIR (where the analysis file will be written)"
printf "(ex: /Volumes/snd/project/sadir/) -> "
set SADIR = "$<"
echo ""
echo "SADIR = $SADIR"
echo ""
echo "enter SSDIR (the directory where you have the file to be analysed)"
printf "(ex: /Volumes/snd/project/ssdir/) -> "
set SSDIR = "$<"
echo ""
echo "SSDIR = $SSDIR"
echo ""
echo "enter file name (the file to be analysed)"
printf "ex: eyjafjallajoekull.aiff -> "
set FILE = "$<"
echo ""
echo ""

echo "enter min amplitude: "
set MINAMP = "$<"
echo ""
echo "enter max freq: "
set MAXFREQ = "$<"
echo ""
echo ""

echo ""
csound -U pvanal -n 1024 -c 1 -w 4 "$SSDIR$FILE" "$SADIR$FILE:r.pvx"
echo ""
csound --omacro:MINAMP=$MINAMP --omacro:MAXFREQ=$MAXFREQ  --omacro:PVOCNAME=$FILE:r.pvx --omacro:AUDIONAME=$FILE --omacro:TXTNAME=$FILE:r.txt --omacro:SADIR=$SADIR --omacro:SSDIR=$SSDIR /usr/local/bin/pvoc2txt2.csd
echo ""
echo "SADIR = $SADIR"
echo "SSDIR = $SSDIR"
echo "file = $FILE"
echo "PVOCNAME= $FILE:r.pvx"
echo "AUDIONAME= $FILE"
echo "TXTNAME= $FILE:r.txt"

